#include <opnet.h>
#include <ema.h>
#include <opnet_emadefs.h>
#include <opnet_constants.h>



/* array for all textlist attributes in model */
VosT_Textlist*		tl_ptr [19];

/* array for all objects in model */
EmaT_Object_Id		obj [55];



main (argc, argv)
	int	argc;
	char	*argv[];
	{
	EmaT_Model_Id			model_id;
	int					i;

	/* initialize EMA package */
	Ema_Init (EMAC_MODE_ERR_PRINT);

	/* create an empty model */
	model_id = Ema_Model_Create (MOD_PROCESS);



	/* create all objects */
	obj [0] = Ema_Object_Create (model_id, OBJ_PR_STATE);
	obj [1] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [2] = Ema_Object_Create (model_id, OBJ_PR_STATE);
	obj [3] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [4] = Ema_Object_Create (model_id, OBJ_PR_STATE);
	obj [5] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [6] = Ema_Object_Create (model_id, OBJ_PR_STATE);
	obj [7] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [8] = Ema_Object_Create (model_id, OBJ_PR_STATE);
	obj [9] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [10] = Ema_Object_Create (model_id, OBJ_PR_STATE);
	obj [11] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [12] = Ema_Object_Create (model_id, OBJ_PR_TRANS);
	obj [13] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [14] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [15] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [16] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [17] = Ema_Object_Create (model_id, OBJ_PR_TRANS);
	obj [18] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [19] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [20] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [21] = Ema_Object_Create (model_id, OBJ_PR_TRANS);
	obj [22] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [23] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [24] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [25] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [26] = Ema_Object_Create (model_id, OBJ_PR_TRANS);
	obj [27] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [28] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [29] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [30] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [31] = Ema_Object_Create (model_id, OBJ_PR_TRANS);
	obj [32] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [33] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [34] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [35] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [36] = Ema_Object_Create (model_id, OBJ_PR_TRANS);
	obj [37] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [38] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [39] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [40] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [41] = Ema_Object_Create (model_id, OBJ_PR_TRANS);
	obj [42] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [43] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [44] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [45] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [46] = Ema_Object_Create (model_id, OBJ_PR_TRANS);
	obj [47] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [48] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [49] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [50] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [51] = Ema_Object_Create (model_id, OBJ_PR_TRANS);
	obj [52] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [53] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [54] = Ema_Object_Create (model_id, OBJ_PR_POS);


	/* set the model level attributes */
	/* create and init textlist 'tl_ptr [0]' */
	tl_ptr [0] = Vos_Textlist_Create ();
	Vos_Textlist_Append (tl_ptr [0], 
		"Objid		\\my_id;",
		"int			\\grp_id,\\sess;",
		"double		\\tim,\\data_rec; ",
		"",
		"int     \\ngrps;",
		"Distribution* \\grp_dist,\\time_dist,\\term_dist;",
		"double 	\\sessmin,\\sessmax,\\data_iat,\\sess_iat;",
		VOSC_EOL);

	/* create and init textlist 'tl_ptr [1]' */
	tl_ptr [1] = Vos_Textlist_Create ();
	Vos_Textlist_Append (tl_ptr [1], 
		"Packet*  pkptr;",
		"int in_strm,da1,da2,da3;",
		"FILE*  fil;",
		"",
		VOSC_EOL);

	/* create and init textlist 'tl_ptr [2]' */
	tl_ptr [2] = Vos_Textlist_Create ();
	Vos_Textlist_Append (tl_ptr [2], 
		"#define	PK_ARR	op_intrpt_type () == OPC_INTRPT_STRM",
		"#define	SELF_INT0	(op_intrpt_type () == OPC_INTRPT_SELF  && op_intrpt_code () == 0)",
		"#define	SELF_INT1	(op_intrpt_type () == OPC_INTRPT_SELF  && op_intrpt_code () == 1)",
		"",
		"#define END_SIM		op_intrpt_type () ==  OPC_INTRPT_ENDSIM",
		VOSC_EOL);

	Ema_Model_Attr_Set (model_id,
		"state vars",           COMP_CONTENTS, tl_ptr [0],
		"temp vars",            COMP_CONTENTS, tl_ptr [1],
		"header block",         COMP_CONTENTS, tl_ptr [2],
		EMAC_EOL);


	/* create model level attribute extensions */
	Ema_Model_Attr_Add (model_id, "NGRPS", EMAC_INTEGER, "", 0);
	Ema_Model_Attr_Add (model_id, "SESSMIN", EMAC_DOUBLE, "sec", (double) 0);
	Ema_Model_Attr_Add (model_id, "SESSMAX", EMAC_DOUBLE, "sec", (double) 0);
	Ema_Model_Attr_Add (model_id, "DATA_IAT", EMAC_DOUBLE, "sec", (double) 0);
	Ema_Model_Attr_Add (model_id, "SESS_IAT", EMAC_DOUBLE, "sec", (double) 0);
	Ema_Model_Attr_Set (model_id,
		"NGRPS",                COMP_PROMOTE, EMAC_DISABLED,
		"SESSMIN",              COMP_PROMOTE, EMAC_DISABLED,
		"SESSMAX",              COMP_PROMOTE, EMAC_DISABLED,
		"DATA_IAT",             COMP_PROMOTE, EMAC_DISABLED,
		"SESS_IAT",             COMP_PROMOTE, EMAC_DISABLED,
		EMAC_EOL);



	/* assign attrs for object 'obj [0]' */
	/* create and init textlist 'tl_ptr [7]' */
	tl_ptr [7] = Vos_Textlist_Create ();
	Vos_Textlist_Append (tl_ptr [7], 
		"",
		"my_id = op_id_self();",
		"",
		"data_rec = 0;",
		"",
		"op_ima_obj_attr_get(my_id,\"NGRPS\",&ngrps);",
		"op_ima_obj_attr_get(my_id,\"SESSMIN\",&sessmin);",
		"op_ima_obj_attr_get(my_id,\"SESSMAX\",&sessmax);",
		"op_ima_obj_attr_get(my_id,\"DATA_IAT\", &data_iat);",
		"op_ima_obj_attr_get(my_id,\"SESS_IAT\",&sess_iat);",
		"",
		"/*generate a RV between 0 and 99 (max of 100 grps to ",
		"select which grp id to join*/",
		"grp_dist = op_dist_load(\"uniform_int\",0,ngrps);",
		"",
		"/*time when he joins initially*/",
		"time_dist = op_dist_load(\"exponential\",sess_iat,0);",
		"tim = op_dist_outcome(time_dist);",
		"op_intrpt_schedule_self((op_sim_time() + tim/100 + 1),0);",
		"sess = 0;",
		"",
		"/*op_ima_obj_attr_get (op_id_self (), \"GRP\",&grp_id);*/",
		"",
		"term_dist = op_dist_load(\"uniform\",sessmin,sessmax);",
		"",
		"",
		VOSC_EOL);

	Ema_Object_Attr_Set (model_id, obj [0], 
		"name",                 COMP_CONTENTS, "init",
		"enter execs",          COMP_CONTENTS, tl_ptr [7],
		"status",               COMP_TOGGLE,   EMAC_ENABLED,
		"position",             COMP_CONTENTS, obj [1],
		"initial",              COMP_TOGGLE,   EMAC_ENABLED,
		EMAC_EOL);


	/* assign attrs for object 'obj [1]' */
	Ema_Object_Attr_Set (model_id, obj [1], 
		"x",                    COMP_CONTENTS, (double) 150,
		"y",                    COMP_CONTENTS, (double) 210,
		EMAC_EOL);


	/* assign attrs for object 'obj [2]' */
	Ema_Object_Attr_Set (model_id, obj [2], 
		"name",                 COMP_CONTENTS, "idle",
		"position",             COMP_CONTENTS, obj [3],
		EMAC_EOL);


	/* assign attrs for object 'obj [3]' */
	Ema_Object_Attr_Set (model_id, obj [3], 
		"x",                    COMP_CONTENTS, (double) 330,
		"y",                    COMP_CONTENTS, (double) 330,
		EMAC_EOL);


	/* assign attrs for object 'obj [4]' */
	/* create and init textlist 'tl_ptr [11]' */
	tl_ptr [11] = Vos_Textlist_Create ();
	Vos_Textlist_Append (tl_ptr [11], 
		"pkptr  = op_pk_get (op_intrpt_strm ());",
		"/*op_pk_nfd_get(pkptr,\"join\",&da1);",
		"op_pk_nfd_get(pkptr,\"terminate\",&da2);",
		"op_pk_nfd_get(pkptr,\"GRP_ID\", &da3);",
		"if(da1 == 0 && da2 == 0)",
		"printf(\"ONLY DATA REACHES APP GRP_ID: %d\\n AND REGISTERED IN %d\",da3,grp_id);",
		"else",
		" printf(\"Something other than data has come here\\n\"); ",
		"",
		"",
		"printf(\"\\nIam a member of %d and got a %d pk\\n\",grp_id,da3);*/",
		"data_rec++;",
		"op_pk_destroy (pkptr);",
		VOSC_EOL);

	Ema_Object_Attr_Set (model_id, obj [4], 
		"name",                 COMP_CONTENTS, "pk_arr",
		"enter execs",          COMP_CONTENTS, tl_ptr [11],
		"status",               COMP_TOGGLE,   EMAC_ENABLED,
		"position",             COMP_CONTENTS, obj [5],
		EMAC_EOL);


	/* assign attrs for object 'obj [5]' */
	Ema_Object_Attr_Set (model_id, obj [5], 
		"x",                    COMP_CONTENTS, (double) 330,
		"y",                    COMP_CONTENTS, (double) 150,
		EMAC_EOL);


	/* assign attrs for object 'obj [6]' */
	/* create and init textlist 'tl_ptr [13]' */
	tl_ptr [13] = Vos_Textlist_Create ();
	Vos_Textlist_Append (tl_ptr [13], 
		"",
		"if(!sess)",
		"{/*session doesn't exist so join*/",
		"grp_id =  op_dist_outcome(grp_dist); ",
		"pkptr = op_pk_create_fmt(\"MC_APP_CNTRL\");",
		"op_pk_nfd_set(pkptr,\"join\",1);",
		"op_pk_nfd_set(pkptr,\"terminate\",0);",
		"op_pk_nfd_set(pkptr,\"GRP_ID\",grp_id);",
		"op_pk_send(pkptr,0);",
		"/*printf(\"Sending a join pk from Appli\\n\");*/",
		"/*for sending data pks*/",
		"op_intrpt_schedule_self(op_sim_time() +(1/data_iat) ,1);",
		"sess=1;",
		"tim = op_dist_outcome(term_dist);",
		"op_intrpt_schedule_self((op_sim_time() + tim),0);",
		"",
		"}",
		"else",
		"{ /*session exists so terminate*/",
		"pkptr = op_pk_create_fmt(\"MC_APP_CNTRL\");",
		"op_pk_nfd_set(pkptr,\"join\",0);",
		"op_pk_nfd_set(pkptr,\"terminate\",1);",
		"op_pk_nfd_set(pkptr,\"GRP_ID\",grp_id);",
		"op_pk_send(pkptr,0);",
		"sess=0;",
		"/*next joining time*/",
		"tim = op_dist_outcome(time_dist);",
		"op_intrpt_schedule_self((op_sim_time() + tim),0);",
		"",
		"}",
		"",
		VOSC_EOL);

	Ema_Object_Attr_Set (model_id, obj [6], 
		"name",                 COMP_CONTENTS, "JOIN_TERM",
		"enter execs",          COMP_CONTENTS, tl_ptr [13],
		"status",               COMP_TOGGLE,   EMAC_ENABLED,
		"position",             COMP_CONTENTS, obj [7],
		EMAC_EOL);


	/* assign attrs for object 'obj [7]' */
	Ema_Object_Attr_Set (model_id, obj [7], 
		"x",                    COMP_CONTENTS, (double) 510,
		"y",                    COMP_CONTENTS, (double) 210,
		EMAC_EOL);


	/* assign attrs for object 'obj [8]' */
	/* create and init textlist 'tl_ptr [15]' */
	tl_ptr [15] = Vos_Textlist_Create ();
	Vos_Textlist_Append (tl_ptr [15], 
		"",
		"if(sess)",
		"{/*create a dummy packet*/",
		"pkptr = op_pk_create_fmt(\"MC_APP_CNTRL\");",
		"op_pk_nfd_set(pkptr,\"join\",0);",
		"op_pk_nfd_set(pkptr,\"terminate\",0);",
		"op_pk_nfd_set(pkptr,\"GRP_ID\",grp_id);",
		"op_pk_send(pkptr,0);",
		"/* printf(\"Sending a data pk\\n\"); */",
		"op_intrpt_schedule_self((op_sim_time() + (1/data_iat)),1);",
		"",
		"}",
		VOSC_EOL);

	Ema_Object_Attr_Set (model_id, obj [8], 
		"name",                 COMP_CONTENTS, "data",
		"enter execs",          COMP_CONTENTS, tl_ptr [15],
		"status",               COMP_TOGGLE,   EMAC_ENABLED,
		"position",             COMP_CONTENTS, obj [9],
		EMAC_EOL);


	/* assign attrs for object 'obj [9]' */
	Ema_Object_Attr_Set (model_id, obj [9], 
		"x",                    COMP_CONTENTS, (double) 330,
		"y",                    COMP_CONTENTS, (double) 450,
		EMAC_EOL);


	/* assign attrs for object 'obj [10]' */
	/* create and init textlist 'tl_ptr [17]' */
	tl_ptr [17] = Vos_Textlist_Create ();
	Vos_Textlist_Append (tl_ptr [17], 
		"",
		"fil = fopen(\"OP\",\"a+\");",
		"",
		"",
		"fprintf(fil,\"\\nAve DATA recieved : %f pks/sec\",data_rec/op_sim_time());",
		"",
		" fclose(fil);",
		"",
		VOSC_EOL);

	Ema_Object_Attr_Set (model_id, obj [10], 
		"name",                 COMP_CONTENTS, "END",
		"enter execs",          COMP_CONTENTS, tl_ptr [17],
		"position",             COMP_CONTENTS, obj [11],
		EMAC_EOL);


	/* assign attrs for object 'obj [11]' */
	Ema_Object_Attr_Set (model_id, obj [11], 
		"x",                    COMP_CONTENTS, (double) 510,
		"y",                    COMP_CONTENTS, (double) 390,
		EMAC_EOL);


	/* assign attrs for object 'obj [12]' */
	Ema_Object_Attr_Set (model_id, obj [12], 
		"name",                 COMP_CONTENTS, "tr_0",
		"dest state",           COMP_CONTENTS, obj [2],
		"src state",            COMP_CONTENTS, obj [0],
		"path",                 COMP_ARRAY_CONTENTS (0), obj [13],
		"path",                 COMP_ARRAY_CONTENTS (1), obj [14],
		"path",                 COMP_ARRAY_CONTENTS (2), obj [15],
		"label pos",            COMP_CONTENTS, obj [16],
		EMAC_EOL);


	/* assign attrs for object 'obj [13]' */
	Ema_Object_Attr_Set (model_id, obj [13], 
		"x",                    COMP_CONTENTS, (double) 158,
		"y",                    COMP_CONTENTS, (double) 236,
		EMAC_EOL);


	/* assign attrs for object 'obj [14]' */
	Ema_Object_Attr_Set (model_id, obj [14], 
		"x",                    COMP_CONTENTS, (double) 163,
		"y",                    COMP_CONTENTS, (double) 296,
		EMAC_EOL);


	/* assign attrs for object 'obj [15]' */
	Ema_Object_Attr_Set (model_id, obj [15], 
		"x",                    COMP_CONTENTS, (double) 302,
		"y",                    COMP_CONTENTS, (double) 329,
		EMAC_EOL);


	/* assign attrs for object 'obj [16]' */
	Ema_Object_Attr_Set (model_id, obj [16], 
		"x",                    COMP_CONTENTS, (double) 160,
		"y",                    COMP_CONTENTS, (double) 266,
		EMAC_EOL);


	/* assign attrs for object 'obj [17]' */
	Ema_Object_Attr_Set (model_id, obj [17], 
		"name",                 COMP_CONTENTS, "tr_1",
		"condition",            COMP_CONTENTS, "PK_ARR",
		"dest state",           COMP_CONTENTS, obj [4],
		"src state",            COMP_CONTENTS, obj [0],
		"path",                 COMP_ARRAY_CONTENTS (0), obj [18],
		"path",                 COMP_ARRAY_CONTENTS (1), obj [19],
		"label pos",            COMP_CONTENTS, obj [20],
		EMAC_EOL);


	/* assign attrs for object 'obj [18]' */
	Ema_Object_Attr_Set (model_id, obj [18], 
		"x",                    COMP_CONTENTS, (double) 176,
		"y",                    COMP_CONTENTS, (double) 197,
		EMAC_EOL);


	/* assign attrs for object 'obj [19]' */
	Ema_Object_Attr_Set (model_id, obj [19], 
		"x",                    COMP_CONTENTS, (double) 302,
		"y",                    COMP_CONTENTS, (double) 149,
		EMAC_EOL);


	/* assign attrs for object 'obj [20]' */
	Ema_Object_Attr_Set (model_id, obj [20], 
		"x",                    COMP_CONTENTS, (double) 239,
		"y",                    COMP_CONTENTS, (double) 173,
		EMAC_EOL);


	/* assign attrs for object 'obj [21]' */
	Ema_Object_Attr_Set (model_id, obj [21], 
		"name",                 COMP_CONTENTS, "tr_2",
		"dest state",           COMP_CONTENTS, obj [2],
		"src state",            COMP_CONTENTS, obj [4],
		"path",                 COMP_ARRAY_CONTENTS (0), obj [22],
		"path",                 COMP_ARRAY_CONTENTS (1), obj [23],
		"path",                 COMP_ARRAY_CONTENTS (2), obj [24],
		"label pos",            COMP_CONTENTS, obj [25],
		EMAC_EOL);


	/* assign attrs for object 'obj [22]' */
	Ema_Object_Attr_Set (model_id, obj [22], 
		"x",                    COMP_CONTENTS, (double) 346,
		"y",                    COMP_CONTENTS, (double) 172,
		EMAC_EOL);


	/* assign attrs for object 'obj [23]' */
	Ema_Object_Attr_Set (model_id, obj [23], 
		"x",                    COMP_CONTENTS, (double) 380,
		"y",                    COMP_CONTENTS, (double) 232,
		EMAC_EOL);


	/* assign attrs for object 'obj [24]' */
	Ema_Object_Attr_Set (model_id, obj [24], 
		"x",                    COMP_CONTENTS, (double) 346,
		"y",                    COMP_CONTENTS, (double) 306,
		EMAC_EOL);


	/* assign attrs for object 'obj [25]' */
	Ema_Object_Attr_Set (model_id, obj [25], 
		"x",                    COMP_CONTENTS, (double) 363,
		"y",                    COMP_CONTENTS, (double) 202,
		EMAC_EOL);


	/* assign attrs for object 'obj [26]' */
	Ema_Object_Attr_Set (model_id, obj [26], 
		"name",                 COMP_CONTENTS, "tr_3",
		"condition",            COMP_CONTENTS, "PK_ARR",
		"dest state",           COMP_CONTENTS, obj [4],
		"src state",            COMP_CONTENTS, obj [2],
		"path",                 COMP_ARRAY_CONTENTS (0), obj [27],
		"path",                 COMP_ARRAY_CONTENTS (1), obj [28],
		"path",                 COMP_ARRAY_CONTENTS (2), obj [29],
		"label pos",            COMP_CONTENTS, obj [30],
		EMAC_EOL);


	/* assign attrs for object 'obj [27]' */
	Ema_Object_Attr_Set (model_id, obj [27], 
		"x",                    COMP_CONTENTS, (double) 310,
		"y",                    COMP_CONTENTS, (double) 309,
		EMAC_EOL);


	/* assign attrs for object 'obj [28]' */
	Ema_Object_Attr_Set (model_id, obj [28], 
		"x",                    COMP_CONTENTS, (double) 280,
		"y",                    COMP_CONTENTS, (double) 254,
		EMAC_EOL);


	/* assign attrs for object 'obj [29]' */
	Ema_Object_Attr_Set (model_id, obj [29], 
		"x",                    COMP_CONTENTS, (double) 313,
		"y",                    COMP_CONTENTS, (double) 172,
		EMAC_EOL);


	/* assign attrs for object 'obj [30]' */
	Ema_Object_Attr_Set (model_id, obj [30], 
		"x",                    COMP_CONTENTS, (double) 295,
		"y",                    COMP_CONTENTS, (double) 281,
		EMAC_EOL);


	/* assign attrs for object 'obj [31]' */
	Ema_Object_Attr_Set (model_id, obj [31], 
		"name",                 COMP_CONTENTS, "tr_4",
		"condition",            COMP_CONTENTS, "SELF_INT0",
		"dest state",           COMP_CONTENTS, obj [6],
		"src state",            COMP_CONTENTS, obj [2],
		"path",                 COMP_ARRAY_CONTENTS (0), obj [32],
		"path",                 COMP_ARRAY_CONTENTS (1), obj [33],
		"path",                 COMP_ARRAY_CONTENTS (2), obj [34],
		"label pos",            COMP_CONTENTS, obj [35],
		EMAC_EOL);


	/* assign attrs for object 'obj [32]' */
	Ema_Object_Attr_Set (model_id, obj [32], 
		"x",                    COMP_CONTENTS, (double) 349,
		"y",                    COMP_CONTENTS, (double) 308,
		EMAC_EOL);


	/* assign attrs for object 'obj [33]' */
	Ema_Object_Attr_Set (model_id, obj [33], 
		"x",                    COMP_CONTENTS, (double) 405,
		"y",                    COMP_CONTENTS, (double) 223,
		EMAC_EOL);


	/* assign attrs for object 'obj [34]' */
	Ema_Object_Attr_Set (model_id, obj [34], 
		"x",                    COMP_CONTENTS, (double) 484,
		"y",                    COMP_CONTENTS, (double) 197,
		EMAC_EOL);


	/* assign attrs for object 'obj [35]' */
	Ema_Object_Attr_Set (model_id, obj [35], 
		"x",                    COMP_CONTENTS, (double) 377,
		"y",                    COMP_CONTENTS, (double) 265,
		EMAC_EOL);


	/* assign attrs for object 'obj [36]' */
	Ema_Object_Attr_Set (model_id, obj [36], 
		"name",                 COMP_CONTENTS, "tr_5",
		"dest state",           COMP_CONTENTS, obj [2],
		"src state",            COMP_CONTENTS, obj [6],
		"path",                 COMP_ARRAY_CONTENTS (0), obj [37],
		"path",                 COMP_ARRAY_CONTENTS (1), obj [38],
		"path",                 COMP_ARRAY_CONTENTS (2), obj [39],
		"label pos",            COMP_CONTENTS, obj [40],
		EMAC_EOL);


	/* assign attrs for object 'obj [37]' */
	Ema_Object_Attr_Set (model_id, obj [37], 
		"x",                    COMP_CONTENTS, (double) 517,
		"y",                    COMP_CONTENTS, (double) 237,
		EMAC_EOL);


	/* assign attrs for object 'obj [38]' */
	Ema_Object_Attr_Set (model_id, obj [38], 
		"x",                    COMP_CONTENTS, (double) 471,
		"y",                    COMP_CONTENTS, (double) 304,
		EMAC_EOL);


	/* assign attrs for object 'obj [39]' */
	Ema_Object_Attr_Set (model_id, obj [39], 
		"x",                    COMP_CONTENTS, (double) 358,
		"y",                    COMP_CONTENTS, (double) 325,
		EMAC_EOL);


	/* assign attrs for object 'obj [40]' */
	Ema_Object_Attr_Set (model_id, obj [40], 
		"x",                    COMP_CONTENTS, (double) 494,
		"y",                    COMP_CONTENTS, (double) 270,
		EMAC_EOL);


	/* assign attrs for object 'obj [41]' */
	Ema_Object_Attr_Set (model_id, obj [41], 
		"name",                 COMP_CONTENTS, "tr_6",
		"condition",            COMP_CONTENTS, "SELF_INT1",
		"dest state",           COMP_CONTENTS, obj [8],
		"src state",            COMP_CONTENTS, obj [2],
		"path",                 COMP_ARRAY_CONTENTS (0), obj [42],
		"path",                 COMP_ARRAY_CONTENTS (1), obj [43],
		"path",                 COMP_ARRAY_CONTENTS (2), obj [44],
		"label pos",            COMP_CONTENTS, obj [45],
		EMAC_EOL);


	/* assign attrs for object 'obj [42]' */
	Ema_Object_Attr_Set (model_id, obj [42], 
		"x",                    COMP_CONTENTS, (double) 311,
		"y",                    COMP_CONTENTS, (double) 350,
		EMAC_EOL);


	/* assign attrs for object 'obj [43]' */
	Ema_Object_Attr_Set (model_id, obj [43], 
		"x",                    COMP_CONTENTS, (double) 296,
		"y",                    COMP_CONTENTS, (double) 387,
		EMAC_EOL);


	/* assign attrs for object 'obj [44]' */
	Ema_Object_Attr_Set (model_id, obj [44], 
		"x",                    COMP_CONTENTS, (double) 309,
		"y",                    COMP_CONTENTS, (double) 430,
		EMAC_EOL);


	/* assign attrs for object 'obj [45]' */
	Ema_Object_Attr_Set (model_id, obj [45], 
		"x",                    COMP_CONTENTS, (double) 303,
		"y",                    COMP_CONTENTS, (double) 368,
		EMAC_EOL);


	/* assign attrs for object 'obj [46]' */
	Ema_Object_Attr_Set (model_id, obj [46], 
		"name",                 COMP_CONTENTS, "tr_8",
		"dest state",           COMP_CONTENTS, obj [2],
		"src state",            COMP_CONTENTS, obj [8],
		"path",                 COMP_ARRAY_CONTENTS (0), obj [47],
		"path",                 COMP_ARRAY_CONTENTS (1), obj [48],
		"path",                 COMP_ARRAY_CONTENTS (2), obj [49],
		"label pos",            COMP_CONTENTS, obj [50],
		EMAC_EOL);


	/* assign attrs for object 'obj [47]' */
	Ema_Object_Attr_Set (model_id, obj [47], 
		"x",                    COMP_CONTENTS, (double) 358,
		"y",                    COMP_CONTENTS, (double) 443,
		EMAC_EOL);


	/* assign attrs for object 'obj [48]' */
	Ema_Object_Attr_Set (model_id, obj [48], 
		"x",                    COMP_CONTENTS, (double) 373,
		"y",                    COMP_CONTENTS, (double) 409,
		EMAC_EOL);


	/* assign attrs for object 'obj [49]' */
	Ema_Object_Attr_Set (model_id, obj [49], 
		"x",                    COMP_CONTENTS, (double) 354,
		"y",                    COMP_CONTENTS, (double) 344,
		EMAC_EOL);


	/* assign attrs for object 'obj [50]' */
	Ema_Object_Attr_Set (model_id, obj [50], 
		"x",                    COMP_CONTENTS, (double) 365,
		"y",                    COMP_CONTENTS, (double) 426,
		EMAC_EOL);


	/* assign attrs for object 'obj [51]' */
	Ema_Object_Attr_Set (model_id, obj [51], 
		"name",                 COMP_CONTENTS, "tr_9",
		"condition",            COMP_CONTENTS, "END_SIM",
		"dest state",           COMP_CONTENTS, obj [10],
		"src state",            COMP_CONTENTS, obj [2],
		"path",                 COMP_ARRAY_CONTENTS (0), obj [52],
		"path",                 COMP_ARRAY_CONTENTS (1), obj [53],
		"label pos",            COMP_CONTENTS, obj [54],
		EMAC_EOL);


	/* assign attrs for object 'obj [52]' */
	Ema_Object_Attr_Set (model_id, obj [52], 
		"x",                    COMP_CONTENTS, (double) 358,
		"y",                    COMP_CONTENTS, (double) 336,
		EMAC_EOL);


	/* assign attrs for object 'obj [53]' */
	Ema_Object_Attr_Set (model_id, obj [53], 
		"x",                    COMP_CONTENTS, (double) 485,
		"y",                    COMP_CONTENTS, (double) 376,
		EMAC_EOL);


	/* assign attrs for object 'obj [54]' */
	Ema_Object_Attr_Set (model_id, obj [54], 
		"x",                    COMP_CONTENTS, (double) 421,
		"y",                    COMP_CONTENTS, (double) 356,
		EMAC_EOL);








	/* write the model to application-readable form */
	Ema_Model_Write (model_id, "Applica1");

	}

